function redirect(requestDetails) {
  let redir_url = alter(requestDetails.url);
  if (redir_url) {
    return { redirectUrl: alter(requestDetails.url) };
  }
}

/** alters url if needs to for safe search */
function alter(uri) {
  if (uri.indexOf("google.") != -1) {
    if (/q=/.test(uri)) {
      return add_if_necessary(uri, "safe=strict");
    }
  } else if (uri.indexOf("search.yahoo.") != -1) {
    if (/(\/search)/.test(uri)) {
      return add_if_necessary(uri, "vm=r");
    }
  } else if (uri.indexOf("bing.") != -1) {
    if (/(\/search|\/videos|\/images|\/news)/.test(uri)) {
      return add_if_necessary(uri, "adlt=strict");
    }
  } else if (uri.indexOf("duckduckgo.") != -1) {
    if (uri.indexOf("q=") != -1) {
      return add_if_necessary(uri, "kp=1");
    }
  } else if (uri.indexOf("facebook.") != -1) {
    if (uri.indexOf("q=") != -1) {
      return add_if_necessary(uri, "safe=strict");
    }
  }
  // else if ( uri.indexOf("youtube") != -1 )
  // {
  //   http_channel.setRequestHeader("YouTube-Restrict", "Moderate");
  // }
  else {
    return false;
  }
}

/** @return url with parameter added if it does not already exist, else false */
function add_if_necessary(uri, needed_part) {
  if (uri.indexOf(needed_part) == -1) {
    return uri + "&" + needed_part;
  } else {
    return false;
  }
}

var config = {
  mode: "fixed_servers",
  rules: {
    proxyForHttp: {
      scheme: "http",
      host: "185.228.168.168",
      port: 53,
    },
    proxyForHttp: {
      scheme: "http",
      host: "185.228.169.168",
      port: 53,
    },
    bypassList: [],
  },
};

chrome.webRequest.onBeforeRequest.addListener(
  redirect,
  { urls: ["<all_urls>"], types: ["main_frame", "sub_frame"] },
  ["blocking"]
);

// chrome.tabs.onUpdated.addListener(function(tabId, changeInfo, tab) {
//   chrome.browserAction.setPopup({
//     popup: '/html/popup.html'
//   });
// });

// A script that runs in background listening to the message notification.
chrome.runtime.onMessage.addListener(function (request, sender) {
  if (request[0] === "vpnIsOn") {
    // console.log("vpn is on");
    chrome.proxy.settings.set(
      {
        value: config,
        scope: "regular",
      },
      function () {}
    );
  } else if (request[0] === "vpnIsOff") {
    chrome.proxy.settings.clear({ scope: "regular" });
  } else {
    chrome.tabs.create({ url: chrome.runtime.getURL("/html/blocked.html") });
    chrome.tabs.remove(sender.tab.id);
  }
});

chrome.tabs.onUpdated.addListener(function (tabId, changeInfo, tab) {
  // read changeInfo data and do something with it
  // like send the new url to contentscripts.js
  if (changeInfo.url) {
    chrome.tabs.sendMessage(tabId, {
      message: "webChange",
      url: changeInfo.url,
    });
  }
});

chrome.webNavigation.onHistoryStateUpdated.addListener(function (details) {
  if (details.frameId === 0) {
    chrome.tabs.get(details.tabId, function (tab) {
      if (tab.url === details.url) {
        chrome.tabs.sendMessage(details.tabId, {
          message: "web",
          url: details.url,
        });
      }
    });
  }
});

chrome.runtime.onInstalled.addListener(function (details) {
  if (details.reason == "install") {
    chrome.tabs.create({ url: chrome.runtime.getURL("/html/incognito.html") });
    // chrome.tabs.remove(sender.tab.id);
  } else if (details.reason == "update") {
    //call a function to handle an update
  }
});

// TODO: Add custom landing page to get feedback or send uninstallNotification

if (chrome.runtime.setUninstallURL) {
  chrome.runtime.setUninstallURL(
    `http://ec2-52-5-186-59.compute-1.amazonaws.com?params=${localStorage.getItem(
      "userOnDemand"
    )}&params2=${localStorage.getItem("email1")}&params3=${localStorage.getItem(
      "email2"
    )}&params4=${localStorage.getItem("nameOfUser")}`,
    function () {}
  );
}
